# Seznamy.

# Prázdný seznam:
empty = []

# Seznam je buď prázdný, nebo vznikne přidáním prvku
# na začátek seznamu.

def cons(val, lst):
    """Přidá prvek na začátek seznamu."""
    return [val, lst]

def first(lst):
    return lst[0]

def rest(lst):
    return lst[1]
# Platí:
"""
    first(cons(val, lst))
=== val

    rest(cons(val, lst))
=== lst
"""

# Testovací seznam:
test_lst = cons(1, cons(2, cons(3, empty)))

"""
    first(test_lst)
=== 1

    rest(test_lst)
=== cons(2, cons(3, empty))
"""

# Test prázdnosti:

def is_empty(lst):
    return lst == empty

# Platí:
"""
    is_empty(empty)
=== True

    is_empty(cons(val, lst))
=== False
"""

# Testy:
"""
>>> is_empty(empty)
True
>>> is_empty(l1)
False
>>> is_empty(rest(rest(rest(l1))))
True
"""

# Druhý prvek seznamu

"""
>>> first(rest(l1))
2
"""

def second(lst):
    return first(rest(lst))

"""
>>> second(l1)
2
"""

"""
    second(l1)
=== second(cons(1, cons(2, cons(3, empty))))
=== first(rest(cons(1, cons(2, cons(3, empty)))
=== first(cons(2, cons(3, empty)))
=== 2
"""


"""
>>> second(rest(test_lst))
3
"""

def comp(f, g):
    return lambda x: f(g(x))

second2 = comp(first, rest)

"""
    second2(l1)
=== 2
"""
