# Mapování seznamu.

empty = []

def cons(val, lst):
    return [val, lst]

def first(lst):
    return lst[0]

def rest(lst):
    return lst[1]

def is_empty(lst):
    return lst == empty

l1 = cons(1, cons(2, cons(3, empty)))

def succ(x):
    return x + 1

def list_map_succ(lst):
    return (empty
            if is_empty(lst)
            else cons(succ(first(lst)),
                      list_map_succ(rest(lst))))

"""
>>> list_map_succ(l1)
[2, [3, [4, []]]]
"""

def square(x):
    return x * x

def list_map_square(lst):
    return (empty
            if is_empty(lst)
            else cons(square(first(lst)),
                      list_map_square(rest(lst))))

"""
>>> list_map_square(l1)
[1, [4, [9, []]]]
"""

def list_map(fun, lst):
    return (empty
            if is_empty(lst)
            else cons(fun(first(lst)),
                      list_map(fun, rest(lst))))

"""
>>> list_map(square, l1)
[1, [4, [9, []]]]
>>> list_map(succ, l1)
[2, [3, [4, []]]]
>>> list_map(lambda x: x - 1, l1)
[0, [1, [2, []]]]
"""
